local lg, lt, le = love.graphics, love.timer, love.event

local shader = lg.newShader[[

extern vec4 base;
extern vec4 maxc;
extern number t;

vec4 effect(vec4 col, Image tex, vec2 imgpos, vec2 scrpos)
{
    vec4 c = Texel(tex, imgpos);
    float i = (sin(t) + 1.) / 2. * c.r;
    i += (sin(t + 2.0943951) + 1.) / 2. * c.g;
    i += (sin(t - 2.0943951) + 1.) / 2. * c.b;
    i = clamp(i, 0., 1.);
    return col * mix(base, maxc, sqrt(i));
}

]]

local rgb = {0,0,1,1}
shader:send('base', rgb)
rgb[1] = 1
rgb[2] = 1
shader:send('maxc', rgb)

local img = lg.newImage('lake-effect.png')

function love.draw()
  shader:send('t', (lt.getTime() % (2* math.pi)) * 7)
  lg.setShader(shader)
  lg.draw(img)
  lg.setShader()
end

function love.keypressed(k)
  return k == "escape" and le.quit()
end
